<?php

namespace MoniBounce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MatchComments StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:MatchComments
 * @subpackage Structs
 */
class MatchComments extends AbstractStructBase
{
    /**
     * The MatchComment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \MoniBounce\StructType\MatchComment[]
     */
    public $MatchComment;
    /**
     * Constructor method for MatchComments
     * @uses MatchComments::setMatchComment()
     * @param \MoniBounce\StructType\MatchComment[] $matchComment
     */
    public function __construct(array $matchComment = array())
    {
        $this
            ->setMatchComment($matchComment);
    }
    /**
     * Get MatchComment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \MoniBounce\StructType\MatchComment[]|null
     */
    public function getMatchComment()
    {
        return isset($this->MatchComment) ? $this->MatchComment : null;
    }
    /**
     * Set MatchComment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \MoniBounce\StructType\MatchComment[] $matchComment
     * @return \MoniBounce\StructType\MatchComments
     */
    public function setMatchComment(array $matchComment = array())
    {
        foreach ($matchComment as $matchCommentsMatchCommentItem) {
            // validation for constraint: itemType
            if (!$matchCommentsMatchCommentItem instanceof \MoniBounce\StructType\MatchComment) {
                throw new \InvalidArgumentException(sprintf('The MatchComment property can only contain items of \MoniBounce\StructType\MatchComment, "%s" given', is_object($matchCommentsMatchCommentItem) ? get_class($matchCommentsMatchCommentItem) : gettype($matchCommentsMatchCommentItem)), __LINE__);
            }
        }
        if (is_null($matchComment) || (is_array($matchComment) && empty($matchComment))) {
            unset($this->MatchComment);
        } else {
            $this->MatchComment = $matchComment;
        }
        return $this;
    }
    /**
     * Add item to MatchComment value
     * @throws \InvalidArgumentException
     * @param \MoniBounce\StructType\MatchComment $item
     * @return \MoniBounce\StructType\MatchComments
     */
    public function addToMatchComment(\MoniBounce\StructType\MatchComment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \MoniBounce\StructType\MatchComment) {
            throw new \InvalidArgumentException(sprintf('The MatchComment property can only contain items of \MoniBounce\StructType\MatchComment, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MatchComment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \MoniBounce\StructType\MatchComments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
